<pre><?
//print_r($_GLOBALS);
//die();
if ($_GLOBALS['VERMINOR']>1191) {

include("/lib/uphp/debug.inc");
include("/lib/uphp/http.inc");
include("/lib/uphp/smtp.inc");

function save_config() {
     $f=fopen("/logs/ahcount.ini","w+");
            if ($f) {
                 $st="[data]\r\n"+
                    "battery_percent="+$_GLOBALS['battery_percent']+"\r\n"+
                    "battery_cur_ah="+$_GLOBALS['battery_cur_ah']+"\r\n"+
                    "charge_cycles="+$_GLOBALS['charge_cycles']+"\r\n"+
                    "discharge_cycles="+$_GLOBALS['discharge_cycles']+"\r\n"+
                    "charge_mode="+$_GLOBALS['charge_mode']+"\r\n";
                    
                fwrite($f,$st);    
                $numgrp=sizeof($_GLOBALS['grp']);
        
                for ($grp=0;$grp < $numgrp; $grp++) {    
                    $str =  "grp".$grp."_ahdin=".$_GLOBALS['grp'][$grp]['vals'][2]."\r\n" +      // ahd_in
                            "grp".$grp."_ahdout=".$_GLOBALS['grp'][$grp]['vals'][3]."\r\n" +    // ahd_out
                            "grp".$grp."_wdin=".$_GLOBALS['grp'][$grp]['vals'][4]."\r\n" +        //wd_in
                            "grp".$grp."_wdout=".$_GLOBALS['grp'][$grp]['vals'][5]."\r\n"+           //wd_out
                            "grp".$grp."_kwhin=".$_GLOBALS['grp'][$grp]['vals'][6]."\r\n" +      // kwh_in
                            "grp".$grp."_kwhout=".$_GLOBALS['grp'][$grp]['vals'][7]."\r\n";     // kww_out                        
                    fwrite($f,$str);
                }
                
                fclose($f);    
            }         
            // write the logged data to disk
            $num_groups = ini_get("/config/datalog.ini","data","num_groups",0);
            for ($i=0;$i<$num_groups;$i++) {
                $s=ini_get("/config/datalog.ini","data",'group'+$i+'status',0);
                if ($s==1) {        
                    if ($_GLOBALS['log'.$i.'buf']) {
                        $f=fopen($logfile,"a");
                        if ($f) {
                            fwrite($f,$_GLOBALS['log'.$i.'buf']);
                            fclose($f);
                        }
                    }
                }
            }
}
$DEBUG_ON=0;
max_execution_time(120);

$ota_stage=ini_get("/logs/ota.ini","config","ota_stage",0);
$ota_update_interval=ini_get("/config/ota.ini","config","ota_interval",86400);
$ota_enabled=ini_get("/config/ota.ini","config","ota_enabled",0);
$ota_auto_install=ini_get("/config/ota.ini","config","ota_auto_install",0);
$ota_auto_resync=ini_get("/config/ota.ini","config","ota_auto_resync",0);
$ota_force_install=ini_get("/config/ota.ini","config","ota_force_install",0);
$ota_firmware=ini_get("/config/ota.ini","config","ota_firmware",0);
$ota_packages=ini_get("/config/ota.ini","config","ota_packages",0);
$ota_custom_packages=ini_get("/config/ota.ini","config","ota_custom_packages",0);
$ota_custom_url=ini_get("/config/ota.ini","config","ota_custom_url",'');
$ota_email=ini_get("/config/ota.ini","config","ota_email",'');
$ota_email_status=ini_get("/config/ota.ini","config","ota_email_status",0);
if (!is_email_valid($ota_email)) {
    $ota_email_status=0;
}
if ($ota_enabled) {
    if ($ota_stage==0) {
        $busy=0;
        if ($ota_firmware || $ota_force_install) {
            $last_update=ini_get("/logs/ota.ini","config","ota_last_run",0);
            if (time()-$last_update > $ota_update_interval) {
                log("Checking for updated firmware");
                $_GLOBALS['sysmsg']="Checking for updated firmware";
                if ((($_SERVER['HW_PLATFORM']>=8) && ($_SERVER['HW_PLATFORM']<=10)) || ($_SERVER['HW_PLATFORM']==12)) {
                    $res=get_json("www.wattmon.com/live/updater.php?action=list&cat=8");
                } else $res=get_json("www.wattmon.com/live/updater.php?action=list&cat=9");
                //print("</pre>");
                $update_array=0;
                if (is_array($res)) {
                    for ($i=0;$i<sizeof($res[0]['files']);$i++) {
                        $v=$res[0]['files'][$i]['version'];
                        $version_array=explode($v,'.');
                        
                        if ($version_array[0]==$_GLOBALS['VERMAJOR']) {
                            if ($version_array[1]>$_GLOBALS['VERMINOR']) {
                                $update_array=$res[0]['files'][$i];
                               // print_r($version_array);
                                //print("MAJOR=".$_GLOBALS['VERMAJOR']." MINOR=".$_GLOBALS['VERMINOR']);
                            }
                        }
                    }
                    if (!$update_array) {
                        print("No firmware update found. ");
                        $_GLOBALS['sysmsg']="No OTA Update found";
                        log("No firmware update found");
                        if (!$ota_packages && !$ota_custom_packages) 
                            ini_set("/logs/ota.ini","config","ota_last_run",time());
                    } else {
                        //print_r($update_array);
                        $already_downloaded=0;
                        if (file_exists('/repository/'.$update_array['filename'])) {
                            $md5_sum=md5_file('/repository/'.$update_array['filename']);
                            if (strtolower($md5_sum)==strtolower($update_array['md5'])) {
                                $already_downloaded=1;
                                log("Firmware ".$update_array['version']." already download.");
                                if ($ota_auto_install || $ota_force_install) {
                                
                                    ini_set("/logs/ota.ini","config","ota_stage",2);
                                    ini_set("/logs/ota.ini","config","ota_type","firmware");
                                    ini_set("/logs/ota.ini","config","ota_version",$update_array['version']);
                                    ini_set("/logs/ota.ini","config","ota_title",$update_array['title']);
                                    ini_set("/logs/ota.ini","config","ota_filename",$update_array['filename']);
                                    ini_set("/logs/ota.ini","config","ota_filesize",$update_array['filesize']);
                                    ini_set("/logs/ota.ini","config","ota_md5",$update_array['md5']);   
                                    $busy=1; // don't check the package now
                                }
                            }
                        }
                        if (!$already_downloaded) {
                        
                            ini_set("/logs/ota.ini","config","ota_stage",1);
                            ini_set("/logs/ota.ini","config","ota_type","firmware");
                            ini_set("/logs/ota.ini","config","ota_version",$update_array['version']);
                            ini_set("/logs/ota.ini","config","ota_filename",$update_array['filename']);
                            ini_set("/logs/ota.ini","config","ota_filesize",$update_array['filesize']);
                            ini_set("/logs/ota.ini","config","ota_title",$update_array['title']);
                            ini_set("/logs/ota.ini","config","ota_md5",$update_array['md5']);
                            $busy=1;
                            $msg="New firmware ".$update_array['version']." found, initiating download";
                            log("New firmware ".$update_array['version']." found, initiating download");
                            $_GLOBALS['sysmsg']="New firmware ".$update_array['version']." found, initiating download";
                            download("www.wattmon.com/phocadownload/".$update_array['filename'],'/repository/'.$update_array['filename']);
                        }
                    }
                }
            }
    
        } 
        
        // firmware update OK, loop through the packages
        if (($ota_packages && !$busy) || $_GET['force_package']) {
            if ($_GET['force_package']) $ota_update_interval=0;    
            $last_update=ini_get("/logs/ota.ini","config","ota_last_run",0);
            if (time()-$last_update > $ota_update_interval) {
                log("Checking for updated packages");
                $_GLOBALS['sysmsg']="Checking for updated packages";
                $res=get_json("www.wattmon.com/live/updater.php?action=list&cat=5");
                //print("</pre>");
                $update_array=0;
               // print_r($res);
//                die();
                if (is_array($res)) {
                    $installed_packages=ini_get_array("/config/packages.ini","packages");
                    //print_r($installed_packages);
                    for ($j=0;$j<sizeof($installed_packages);$j++) {
                        // don't continue if we already have a package to install
                        if ($update_array) break;
                        $package_name=array_key($installed_packages,$j);
                        if ($installed_packages[$package_name]==2) {
                            $package_name=strtolower($package_name);
                            
                            for ($i=0;$i<sizeof($res[0]['files']);$i++) {
                                $v=$res[0]['files'][$i]['version'];
                                $package=$res[0]['files'][$i]['filename'];
                                $package=strtolower(substr($package,0,strpos($package,'_')));
                                if ($package==$package_name) {
                                    $installed_v=ini_get("/package/".$package.".ini","package","version","");
                                    if ($installed_v<$v) {
                                        $update_array=$res[0]['files'][$i];
                                    }
                                }
                            }
                        }
                    }
                    if (!$update_array) {
                        print("No package update found. \r\n");
                        $_GLOBALS['sysmsg']="No OTA Update found";
                        log("No package update found");
                        if (!$ota_custom_packages) {
                            ini_set("/logs/ota.ini","config","ota_last_run",time());
                            $need_resync=ini_get("/logs/ota.ini","config","need_resync",0);
                            if ($ota_auto_resync && $need_resync) {
                               include("/scripts/md5_resync.cgi");
                            }
                        }
                    } else {
                        //print_r($update_array);
                        $already_downloaded=0;
                        $busy=1;
                        print($update_array['title']." version ".$installed_v." will be replaced with version ".$update_array['version'].".\r\n");
                        log("OTA: ".$update_array['title']." version ".$installed_v." will be replaced with version ".$update_array['version'].". ");
                        if (file_exists('/repository/'.$update_array['filename'])) {
                            $md5_sum=md5_file('/repository/'.$update_array['filename']);
                            if (strtolower($md5_sum)==strtolower($update_array['md5'])) {
                                $already_downloaded=1;
                                log("Package ".$update_array['version']." already download.");
                                print("Package ".$update_array['version']." already download.");
                                if (!$ota_auto_install && !$ota_force_install) {
                                    log("OTA auto install is not enabled.  You can find the new file in /repository/".$ota_filename);
                                    $_GLOBALS['sysmsg']="OTA auto install is not enabled.  You can find the new file in /repository/".$ota_filename;
                                    ini_set("/logs/ota.ini","config","ota_stage",0); // restart
                                    ini_set("/logs/ota.ini","config","ota_last_run",time()); // make it re-run quickly
                                } else {
                                    print("It will be automatically installed shortly. ");
                                    ini_set("/logs/ota.ini","config","ota_stage",2);
                                    ini_set("/logs/ota.ini","config","ota_type","package");
                                    ini_set("/logs/ota.ini","config","ota_version",$update_array['version']);
                                    ini_set("/logs/ota.ini","config","ota_title",$update_array['title']);
                                    ini_set("/logs/ota.ini","config","ota_filename",$update_array['filename']);
                                    ini_set("/logs/ota.ini","config","ota_filesize",$update_array['filesize']);
                                    ini_set("/logs/ota.ini","config","ota_md5",$update_array['md5']);
                                    
                                }
                            }
                        }
                        if (!$already_downloaded) {
                            ini_set("/logs/ota.ini","config","ota_stage",1);
                            ini_set("/logs/ota.ini","config","ota_type","package");
                            ini_set("/logs/ota.ini","config","ota_version",$update_array['version']);
                            ini_set("/logs/ota.ini","config","ota_filename",$update_array['filename']);
                            ini_set("/logs/ota.ini","config","ota_filesize",$update_array['filesize']);
                            ini_set("/logs/ota.ini","config","ota_title",$update_array['title']);
                            ini_set("/logs/ota.ini","config","ota_md5",$update_array['md5']);
                            $busy=1;
                            $msg="New package ".$update_array['version']." found, initiating download";
                            print("New package ".$update_array['version']." found, initiating download");
                            log("New package ".$update_array['title']." version ".$update_array['version']." found, initiating download");
                            $_GLOBALS['sysmsg']="New package ".$update_array['version']." found, initiating download";
                            download("www.wattmon.com/phocadownload/".$update_array['filename'],'/repository/'.$update_array['filename']);
                        }
                    }
                }
            }
        }
        
        if (($ota_custom_packages && !$busy) || $_GET['force_custom_package']) {
            if ($_GET['force_custom_package']) $ota_update_interval=0;    
            $last_update=ini_get("/logs/ota.ini","config","ota_last_run",0);
            if (time()-$last_update > $ota_update_interval) {
                log("Checking for updated custom packages");
                $_GLOBALS['sysmsg']="Checking for updated custom packages... ";
                print("Checking for updated packages in custom repository...");
                $res=get_json($ota_custom_url);
                //print("</pre>");
                $update_array=0;
           //     print_r($res);
//                die();
                if (is_array($res)) {
                    $installed_packages=ini_get_array("/config/packages.ini","packages");
                    //print_r($installed_packages);
                    for ($j=0;$j<sizeof($installed_packages);$j++) {
                        // don't continue if we already have a package to install
                        if ($update_array) break;
                        $package_name=array_key($installed_packages,$j);
                        if ($installed_packages[$package_name]==2) {
                            $package_name=strtolower($package_name);
                            
                            for ($i=0;$i<sizeof($res[0]['files']);$i++) {
                                $v=$res[0]['files'][$i]['version'];
                                $package=$res[0]['files'][$i]['filename'];
                                $package=strtolower(substr($package,0,strpos($package,'_')));
                                if ($package==$package_name) {
                                    $installed_v=ini_get("/package/".$package.".ini","package","version","");
                                    if ($installed_v<$v) {
                                        $update_array=$res[0]['files'][$i];
                                    }
                                }
                            }
                        }
                    }
                    if (!$update_array) {
                        print("No custom package update found. \r\n");
                        $_GLOBALS['sysmsg']="No custom package update found";
                        log("No package update found");
                        ini_set("/logs/ota.ini","config","ota_last_run",time());
                        $need_resync=ini_get("/logs/ota.ini","config","need_resync",0);
                        if ($ota_auto_resync && $need_resync) {
                           include("/scripts/md5_resync.cgi");
                        
                        }
                    } else {
                        //print_r($update_array);
                        $already_downloaded=0;
                        $busy=1;
                        print($update_array['title']." version ".$installed_v." will be replaced with version ".$update_array['version'].".\r\n");
                        log("OTA: ".$update_array['title']." version ".$installed_v." will be replaced with version ".$update_array['version'].". ");
                        if (file_exists('/repository/'.$update_array['filename'])) {
                            $md5_sum=md5_file('/repository/'.$update_array['filename']);
                            if (strtolower($md5_sum)==strtolower($update_array['md5'])) {
                                $already_downloaded=1;
                                log("Package ".$update_array['version']." already download.");
                                print("Package ".$update_array['version']." already download.");
                                if (!$ota_auto_install && !$ota_force_install) {
                                    log("OTA auto install is not enabled.  You can find the new file in /repository/".$ota_filename);
                                    $_GLOBALS['sysmsg']="OTA auto install is not enabled.  You can find the new file in /repository/".$ota_filename;
                                    ini_set("/logs/ota.ini","config","ota_stage",0); // restart
                                    ini_set("/logs/ota.ini","config","ota_last_run",time()); // make it re-run quickly
                                } else {
                                    print("It will be automatically installed shortly. ");
                                    ini_set("/logs/ota.ini","config","ota_stage",2);
                                    ini_set("/logs/ota.ini","config","ota_type","package");
                                    ini_set("/logs/ota.ini","config","ota_version",$update_array['version']);
                                    ini_set("/logs/ota.ini","config","ota_title",$update_array['title']);
                                    ini_set("/logs/ota.ini","config","ota_filename",$update_array['filename']);
                                    ini_set("/logs/ota.ini","config","ota_filesize",$update_array['filesize']);
                                    ini_set("/logs/ota.ini","config","ota_md5",$update_array['md5']);
                                    
                                }
                            }
                        }
                        if (!$already_downloaded) {
                            ini_set("/logs/ota.ini","config","ota_stage",1);
                            ini_set("/logs/ota.ini","config","ota_type","package");
                            ini_set("/logs/ota.ini","config","ota_version",$update_array['version']);
                            ini_set("/logs/ota.ini","config","ota_filename",$update_array['filename']);
                            ini_set("/logs/ota.ini","config","ota_filesize",$update_array['filesize']);
                            ini_set("/logs/ota.ini","config","ota_title",$update_array['title']);
                            ini_set("/logs/ota.ini","config","ota_md5",$update_array['md5']);
                            $busy=1;
                            $msg="New custom package ".$update_array['version']." found, initiating download";
                            print("New custom package ".$update_array['version']." found, initiating download");
                            log("New custom package ".$update_array['title']." version ".$update_array['version']." found, initiating download");
                            $_GLOBALS['sysmsg']="New package ".$update_array['version']." found, initiating download";
                            if ($update_array['base_url']) 
                                download($update_array['base_url'].$update_array['filename'],'/repository/'.$update_array['filename']);
                            else
                                download("www.wattmon.com/phocadownload/".$update_array['filename'],'/repository/'.$update_array['filename']);
                        }
                    }
                }
            }
        }
    } else if ($ota_stage==1) { // OTA update is happening
        $res=download_info();
        
        if ($res['size'] == $res['filesize']) {
            
            
            $ota_filename=ini_get("/logs/ota.ini","config","ota_filename",'');
            $ota_filesize=ini_get("/logs/ota.ini","config","ota_filesize",0);
            $ota_md5=ini_get("/logs/ota.ini","config","ota_md5",'');
            $md5=strtolower(md5_file('/repository/'.$ota_filename));
            print_r($res);
            
            if ($md5!=$ota_md5) {
                log("OTA Update Failure: invalid MD5 checksum");
                ini_set("/logs/ota.ini","config","ota_stage",0); // restart
                if ($ota_email_status) {
                    $res=mail($ota_email,"OTA Update for ".getmac()." failed","The MD5 Checksum for the update of ".$ota_filename);
                    if ($res!=0) 
                        log("Error sending mail - error code is: ".$res);
                }
                //ini_set("/logs/ota.ini","config","ota_last_run",0); // make it re-run quickly
                print("MD5: ".$md5);
            } else {
                print("Download completed!");
                
                log("OTA firmware succesfully downloaded");
                $_GLOBALS['sysmsg']="OTA firmware succesfully downloaded";
                if (!$ota_auto_install && !$ota_force_install) {
                    log("OTA auto install is not enabled.  You can find the new file in /repository/".$ota_filename);
                    $_GLOBALS['sysmsg']="OTA auto install is not enabled.  You can find the new file in /repository/".$ota_filename;
                    if ($ota_email_status) {
                        $res=mail($ota_email,"OTA Update for ".getmac()." download","The firmare update file ".$ota_filename." has been downloaded and placed in the /repository/ folder.  It has not been installed as you have disabled this option.");
                        if ($res!=0) 
                            log("Error sending mail - error code is: ".$res);
                    }
                    
                    ini_set("/logs/ota.ini","config","ota_stage",0); // restart
                    ini_set("/logs/ota.ini","config","ota_last_run",time()); // make it re-run quickly
                } else ini_set("/logs/ota.ini","config","ota_stage",2); // restart
            }
        } else {
            log("Downloading ".$res['size']." of ".$res['filesize']);
            $_GLOBALS['sysmsg']='OTA Update '.intval(100*$res['size']/$res['filesize'])."% downloaded";
            print("Downloading file... ");
            print_r($res);
            if ($res['state']>=10) {
                print("Download error");
                $_GLOBALS['sysmsg']='OTA Update file is corrrupt.';
                log("OTA download failed ".$res['size']." of ".$res['filesize']." code=".$res['state']);
                ini_set("/logs/ota.ini","config","ota_stage",0); // restart
                ini_set("/logs/ota.ini","config","ota_last_run",0); // make it re-run quickly
            }
        }
    
    
    } else if ($ota_stage==2) { // OTA update is happening
        print("Extracting");
        $_GLOBALS['sysmsg']='OTA Update file is being extracted';
        $ota_filename=ini_get("/logs/ota.ini","config","ota_filename",'');
        
        $dir=getcwd();
        chdir("/");
        $res=untar("/repository/".$ota_filename);
        chdir($dir);
        
        ini_set("/logs/ota.ini","config","ota_stage",0); // restart
        ini_set("/logs/ota.ini","config","ota_force_install",0); //
        
        //ini_set("/logs/ota.ini","config","ota_last_run",time()); // make it re-run quickly
        $type=ini_get("/logs/ota.ini","config","ota_type","firmware");
        if ($type=='firmware') {
            $_GLOBALS['sysmsg']='OTA Update file extracted, starting firmware update.';
            log("OTA: File is extracted ".$res." starting firmware update");
            $ota_version=ini_get("/logs/ota.ini","config","ota_version",'');
            
            
            if ($ota_email_status) {
                        $res=mail($ota_email,"Wattmon ".getmac()." firmware updated to ".$ota_version,"The firmare update file ".$ota_filename." is about to be installed and the device will reboot.");
                        if ($res!=0) 
                            log("Error sending mail - error code is: ".$res);
            }
            
          save_config();
        firmwareupdate();
        } else {
            ini_set("/logs/ota.ini","config","need_resync",1);
            $ota_version=ini_get("/logs/ota.ini","config","ota_version",'');
            $ota_title=ini_get("/logs/ota.ini","config","ota_title",'');
            $package_name=substr($ota_filename,0,strpos($ota_filename,'_'));
            
            // always update the install date
            ini_set("/package/".$package_name.".ini","package","install_date",strftime("%c",time()));
            ini_set("/package/".$package_name.".ini","package","install_method","Updated via OTA from online repository");
            $need_reboot=ini_get("/package/".$package_name.".ini","package","need_reboot",0);
            
            if ($ota_email_status) {
                $res=mail($ota_email,"Wattmon ".getmac()." package ".$ota_title." updated to ".$ota_version,"The package update file ".$ota_filename." has been installed. ".($need_reboot?"Wattmon is going to restart now as this package requires it.":""));
                if ($res!=0) 
                    log("Error sending mail - error code is: ".$res);
            }
            
            $_GLOBALS['sysmsg']='OTA Package install completed.';
            log("OTA: File is extracted successfully");
            if ($need_reboot) {
                log("OTA: Initiating reboot");
                save_config();
                reset();
            }
        }
        
    }
}
} else {
    print("Not supported in this firmware");
}
?></pre>


